package javax.crypto;

import java.security.Key;

/**
 * A secret (symmetric) key.
 * <p>
 * This interface contains no methods or constants.
 * Its only purpose is to group (and provide type safety for) secret keys.
 * <p>
 * Provider implementations of this interface must overwrite the
 *  equals</code> and  hashCode</code> methods inherited from
 *  java.lang.Object</code>, so that secret keys are compared based on
 * their underlying key material and not based on reference.
 * <p>
 * Keys that implement this interface return the string  RAW</code>
 * as their encoding format (see  getFormat</code>), and return the
 * raw key bytes as the result of a  getEncoded</code> method call. (The
 *  getFormat</code> and  getEncoded</code> methods are inherited
 * from the  java.security.Key</code> parent interface.)
 *
 * @see SecretKeyFactory
 * @see Cipher
 */
public abstract interface SecretKey
    extends Key
{
}
